//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <ipl.h>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

bool acabar= false;

//---------------------------------------------------------------------------

/////////////////////////////////////////////////////////////////
//////// COPIADO DEL EJEMPLO: OPENCV\SAMPLES\C\SQUARES.C ////////
/////////////////////////////////////////////////////////////////
CvPoint pt[4];

double angle( CvPoint* pt1, CvPoint* pt2, CvPoint* pt0 )
{
    double dx1 = pt1->x - pt0->x;
    double dy1 = pt1->y - pt0->y;
    double dx2 = pt2->x - pt0->x;
    double dy2 = pt2->y - pt0->y;
    return (dx1*dx2 + dy1*dy2)/sqrt((dx1*dx1 + dy1*dy1)*(dx2*dx2 + dy2*dy2) + 1e-10);
}

// returns sequence of squares detected on the image.
// the sequence is stored in the specified memory storage
CvSeq* findSquares4( IplImage* img, CvMemStorage* storage )
{
    CvSeq* contours;
    int i, c, l, N = 11;
    CvSize sz = cvSize( img->width & -2, img->height & -2 );
    IplImage* timg = cvCloneImage( img ); // make a copy of input image
    IplImage* gray = cvCreateImage( sz, 8, 1 ); 
    IplImage* pyr = cvCreateImage( cvSize(sz.width/2, sz.height/2), 8, 3 );
    IplImage* tgray;
    CvSeq* result;
    double s, t;
    // create empty sequence that will contain points -
    // 4 points per square (the square's vertices)
    CvSeq* squares = cvCreateSeq( 0, sizeof(CvSeq), sizeof(CvPoint), storage );
    
    // select the maximum ROI in the image
    // with the width and height divisible by 2
    cvSetImageROI( timg, cvRect( 0, 0, sz.width, sz.height ));
    
    // down-scale and upscale the image to filter out the noise
    cvPyrDown( timg, pyr, 7 );
    cvPyrUp( pyr, timg, 7 );
    tgray = cvCreateImage( sz, 8, 1 );
    
    // find squares in every color plane of the image
    for( c = 0; c < 3; c++ )
    {
        // extract the c-th color plane
        cvSetImageCOI( timg, c+1 );
        cvCopy( timg, tgray, 0 );
        
        // try several threshold levels
        for( l = 0; l < N; l++ )
        {
            // hack: use Canny instead of zero threshold level.
            // Canny helps to catch squares with gradient shading   
            if( l == 0 )
            {
                // apply Canny. Take the upper threshold from slider
                // and set the lower to 0 (which forces edges merging) 
                cvCanny( tgray, gray, 0, 80, 5 );
                // dilate canny output to remove potential
                // holes between edge segments 
                cvDilate( gray, gray, 0, 1 );
            }
            else
            {
                // apply threshold if l!=0:
                //     tgray(x,y) = gray(x,y) < (l+1)*255/N ? 255 : 0
                cvThreshold( tgray, gray, (l+1)*255/N, 255, CV_THRESH_BINARY );
            }
            
            // find contours and store them all as a list
            cvFindContours( gray, storage, &contours, sizeof(CvContour),
                CV_RETR_LIST, CV_CHAIN_APPROX_SIMPLE, cvPoint(0,0) );
            
            // test each contour
            while( contours )
            {
                // approximate contour with accuracy proportional
                // to the contour perimeter
                result = cvApproxPoly( contours, sizeof(CvContour), storage,
                    CV_POLY_APPROX_DP, cvContourPerimeter(contours)*0.02, 0 );
                // square contours should have 4 vertices after approximation
                // relatively large area (to filter out noisy contours)
                // and be convex.
                // Note: absolute value of an area is used because
                // area may be positive or negative - in accordance with the
                // contour orientation
                if( result->total == 4 &&
                    fabs(cvContourArea(result,CV_WHOLE_SEQ)) > 1000 &&
                    cvCheckContourConvexity(result) )
                {
                    s = 0;
                    
                    for( i = 0; i < 5; i++ )
                    {
                        // find minimum angle between joint
                        // edges (maximum of cosine)
                        if( i >= 2 )
                        {
                            t = fabs(angle(
                            (CvPoint*)cvGetSeqElem( result, i ),
                            (CvPoint*)cvGetSeqElem( result, i-2 ),
                            (CvPoint*)cvGetSeqElem( result, i-1 )));
                            s = s > t ? s : t;
                        }
                    }
                    
                    // if cosines of all angles are small
                    // (all angles are ~90 degree) then write quandrange
                    // vertices to resultant sequence 
                    if( s < 0.3 )
                        for( i = 0; i < 4; i++ )
                            cvSeqPush( squares,
                                (CvPoint*)cvGetSeqElem( result, i ));
                }
                
                // take the next contour
                contours = contours->h_next;
            }
        }
    }
    
    // release all the temporary images
    cvReleaseImage( &gray );
    cvReleaseImage( &pyr );
    cvReleaseImage( &tgray );
    cvReleaseImage( &timg );
    
    return squares;
}


// the function draws all the squares in the image
void drawSquares( IplImage* img, CvSeq* squares )
{
    CvSeqReader reader;
    IplImage* cpy = cvCloneImage( img );
    int i;
    
    // initialize reader of the sequence
    cvStartReadSeq( squares, &reader, 0 );
    
    // read 4 sequence elements at a time (all vertices of a square)
    for( i = 0; i < squares->total; i += 4 )
    {
        CvPoint* rect = pt;
        int count = 4;
        
        // read 4 vertices
        memcpy( pt, reader.ptr, squares->elem_size );
        CV_NEXT_SEQ_ELEM( squares->elem_size, reader );
        memcpy( pt + 1, reader.ptr, squares->elem_size );
        CV_NEXT_SEQ_ELEM( squares->elem_size, reader );
        memcpy( pt + 2, reader.ptr, squares->elem_size );
        CV_NEXT_SEQ_ELEM( squares->elem_size, reader );
        memcpy( pt + 3, reader.ptr, squares->elem_size );
        CV_NEXT_SEQ_ELEM( squares->elem_size, reader );
        
        // draw the square as a closed polyline 
        cvPolyLine( cpy, &rect, &count, 1, 1, CV_RGB(0,255,0), 3, CV_AA, 0 );
    }
    
    // show the resultant image
    cvNamedWindow( "Cuadrados", 0 );
    cvShowImage( "Cuadrados", cpy );
    cvReleaseImage( &cpy );
}
//////////////////////////////////////////////////////////////////////
//////// FIN DEL TROZO COPIADO DE: OPENCV\SAMPLES\C\SQUARES.C ////////
//////////////////////////////////////////////////////////////////////

void lineas (IplImage *src)
{
        IplImage* gsrc = cvCreateImage( cvGetSize(src), 8, 1 );
        IplImage* dst = cvCreateImage( cvGetSize(src), 8, 1 );
        IplImage* color_dst = cvCreateImage( cvGetSize(src), 8, 3 );
        CvMemStorage* storage = cvCreateMemStorage(0);
        CvSeq* lines = 0;
        int i;
        cvCvtColor( src, gsrc, CV_BGR2GRAY );
        cvSmooth( gsrc, gsrc, CV_GAUSSIAN );
        if (Form1->ComboBox1->ItemIndex==0) {
//
// METODO 1: CONTORNOS
//
          drawSquares( src, findSquares4( src, storage ) );
        }
        else {
//
// METODO 2: TRANSFORMADA DE HOUGH
//
          cvCanny( gsrc, dst, 100, 250, 3 );
          cvCvtColor( dst, color_dst, CV_GRAY2BGR );
          if (Form1->ComboBox1->ItemIndex==1 || Form1->ComboBox1->ItemIndex==3) {
            if (Form1->ComboBox1->ItemIndex==1)
//
// METODO 2.1: HOUGH CLASICO
//
              lines = cvHoughLines2(dst, storage, CV_HOUGH_STANDARD, 1, CV_PI/180, Form1->TrackBar1->Position*3);
            else
//
// METODO 2.2: HOUGH MULTI-ESCALA
//
              lines = cvHoughLines2(dst, storage, CV_HOUGH_MULTI_SCALE, 4, CV_PI/90, Form1->TrackBar1->Position*6, 2, 2);
            for( i = 0; i < MIN(lines->total,100); i++ ) {
              float* line = (float*)cvGetSeqElem(lines,i);
              float rho = line[0];
              float theta = line[1];
              CvPoint pt1, pt2;
              double a = cos(theta), b = sin(theta);
              double x0 = a*rho, y0 = b*rho;
              pt1.x = cvRound(x0 + 1000*(-b));
              pt1.y = cvRound(y0 + 1000*(a));
              pt2.x = cvRound(x0 - 1000*(-b));
              pt2.y = cvRound(y0 - 1000*(a));
              cvLine( src, pt1, pt2, CV_RGB(255,0,0), 3, 8 );
            }
          }
          else {
//
// METODO 2.3: HOUGH PROBABILISTICO
//
            lines = cvHoughLines2( dst, storage, CV_HOUGH_PROBABILISTIC, 1, CV_PI/90, Form1->TrackBar1->Position, 50, 8);
            for( i = 0; i < lines->total; i++ ) {
              CvPoint* line = (CvPoint*)cvGetSeqElem(lines,i);
              cvLine( src, line[0], line[1], CV_RGB(0,255,255), 3, 8 );
            }
          }
          cvNamedWindow("Bordes de Canny", 0);
          cvShowImage("Bordes de Canny", color_dst);
          cvNamedWindow("Cuadrados", 0);
          cvShowImage("Cuadrados", src);
        }
        cvReleaseImage(&dst);
        cvReleaseImage(&gsrc);
        cvReleaseImage(&color_dst);
        cvReleaseMemStorage(&storage);
}


void __fastcall TForm1::Button1Click(TObject *Sender)
{
  // 1. Abrir la fuente de vdeo
  CvCapture *cap= NULL;
  acabar= false;
  // 1.1. De cmara
  if (RadioButton1->Checked) {
    cap= cvCaptureFromCAM(-1);
  }
  // 1.2. O de archivo AVI
  else {
    if (OpenDialog1->Execute())
      cap= cvCaptureFromAVI(OpenDialog1->FileName.c_str());
  }
  if (!cap) {
    if (RadioButton1->Checked)
      ShowMessage("No se puede encontrar ninguna cmara.");
    else
      ShowMessage("El archivo no se encuentra o no es un AVI vlido.");
    return;
  }

  Button1->Enabled= false;
  CvMemStorage *storage = cvCreateMemStorage(0);
  IplImage *img= cvQueryFrame(cap);
  IplImage *cop= cvCloneImage(img);
  cop->origin= 0;

  // 2. Para cada frame, hasta que se acabe el vdeo o se pulse una tecla
  while (img && cvWaitKey(1)==-1 && !acabar) {
    // 2.1. Copiar la imagen en top-left
    if (img->origin==0)
      cvCopy(img, cop);
    else
      cvFlip(img, cop);
    cvNamedWindow("Entrada", 0);
    cvShowImage("Entrada", cop);
    Application->ProcessMessages();
    // 2.2. Ejecutar el cdigo de deteccin de rectngulos
    lineas(cop);
    // 2.3. Siguiente frame
    img= cvQueryFrame(cap);
  }

  // 3. Acabar liberando memoria
  cvReleaseCapture(&cap);
  cvReleaseImage(&cop);
  cvReleaseMemStorage(&storage);
  Button1->Enabled= true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  acabar= true;      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  acabar= true;      
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Top= 0;
  Left= Screen->Width/2-Width/2;      
}
//---------------------------------------------------------------------------

